%     VIRTUAL SORIC - программа для получения эффективных свойств заполнителей SORIC
%     Copyright (C) 2020  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Points = Construct_Geometry(Soric_Model, RVE_Length_1, RVE_Length_2, Web_Volume_Fraction)

global ErrCode;

Points = [];

fprintf (1, 'Создание базовых точек ячейки периодичности...          ');

switch Soric_Model
    
    case 'CONSTANT_WEB'
        
        t = (RVE_Length_1 + sqrt(3)*RVE_Length_2 - sqrt((RVE_Length_1 + sqrt(3)*RVE_Length_2)^2 - 4*sqrt(3)*Web_Volume_Fraction*RVE_Length_1*RVE_Length_2)) / (2*sqrt(3));
        b = (RVE_Length_2 - t) / sqrt(3);
        a = RVE_Length_1/2 - RVE_Length_2/2/sqrt(3) - t/sqrt(3);
        
        Points = zeros(31,2);
        
        Points(1,:) = [RVE_Length_1 / 2, RVE_Length_2 / 2];
        
        Points(27,:) = [0, 0];
        Points(28,:) = [0, sqrt(3)/2 * b];
        Points(29,:) = [0, sqrt(3)/2 * b + t];
        Points(30,:) = [0, RVE_Length_2];
        Points(15,:) = [a/2 + b/2, 0];
        Points(16,:) = [a/2, sqrt(3)/2 * b];
        Points(17,:) = [a/2, sqrt(3)/2 * b + t];
        Points(18,:) = [a/2 + b/2, RVE_Length_2];
        
        Points(25,:) = [RVE_Length_1, 0];
        Points(24,:) = [RVE_Length_1, sqrt(3)/2 * b];
        Points(23,:) = [RVE_Length_1, sqrt(3)/2 * b + t];
        Points(22,:) = [RVE_Length_1, RVE_Length_2];
        Points(12,:) = [RVE_Length_1 - a/2 - b/2, 0];
        Points(11,:) = [RVE_Length_1 - a/2, sqrt(3)/2 * b];
        Points(10,:) = [RVE_Length_1 - a/2, sqrt(3)/2 * b + t];
        Points(21,:) = [RVE_Length_1 - a/2 - b/2, RVE_Length_2];
        
        Points(2,:) = [RVE_Length_1/2 + a/2 + b/2, RVE_Length_2/2];
        Points(6,:) = [RVE_Length_1/2 - a/2 - b/2, RVE_Length_2/2];
        Points(4,:) = [RVE_Length_1/2, RVE_Length_2/2 + sqrt(3)/2 * b];
        Points(8,:) = [RVE_Length_1/2, RVE_Length_2/2 - sqrt(3)/2 * b];
        
        Points(3,:) = [RVE_Length_1/2 + a/2, RVE_Length_2/2 + sqrt(3)/2 * b];
        Points(5,:) = [RVE_Length_1/2 - a/2, RVE_Length_2/2 + sqrt(3)/2 * b];
        Points(7,:) = [RVE_Length_1/2 - a/2, RVE_Length_2/2 - sqrt(3)/2 * b];
        Points(9,:) = [RVE_Length_1/2 + a/2, RVE_Length_2/2 - sqrt(3)/2 * b];
        
        Points(14,:) = [RVE_Length_1/2 - a/2, 0];
        Points(26,:) = [RVE_Length_1/2, 0];
        Points(13,:) = [RVE_Length_1/2 + a/2, 0];
        
        Points(19,:) = [RVE_Length_1/2 - a/2, RVE_Length_2];
        Points(31,:) = [RVE_Length_1/2, RVE_Length_2];
        Points(20,:) = [RVE_Length_1/2 + a/2, RVE_Length_2];
        
    case 'RIGHT_HEX'
        
        a = sqrt((1-Web_Volume_Fraction)*RVE_Length_1*RVE_Length_2/3/sqrt(3));
        t2 = RVE_Length_2 - sqrt((1-Web_Volume_Fraction)*RVE_Length_1*RVE_Length_2/sqrt(3));
        
        Points = zeros(31,2);
        
        Points(1,:) = [RVE_Length_1 / 2, RVE_Length_2 / 2];
        
        Points(27,:) = [0, 0];
        Points(28,:) = [0, sqrt(3)/2 * a];
        Points(29,:) = [0, sqrt(3)/2 * a + t2];
        Points(30,:) = [0, RVE_Length_2];
        Points(15,:) = [a, 0];
        Points(16,:) = [a/2, sqrt(3)/2 * a];
        Points(17,:) = [a/2, sqrt(3)/2 * a + t2];
        Points(18,:) = [a, RVE_Length_2];
        
        Points(25,:) = [RVE_Length_1, 0];
        Points(24,:) = [RVE_Length_1, sqrt(3)/2 * a];
        Points(23,:) = [RVE_Length_1, sqrt(3)/2 * a + t2];
        Points(22,:) = [RVE_Length_1, RVE_Length_2];
        Points(12,:) = [RVE_Length_1 - a, 0];
        Points(11,:) = [RVE_Length_1 - a/2, sqrt(3)/2 * a];
        Points(10,:) = [RVE_Length_1 - a/2, sqrt(3)/2 * a + t2];
        Points(21,:) = [RVE_Length_1 - a, RVE_Length_2];
        
        Points(2,:) = [RVE_Length_1/2 + a, RVE_Length_2/2];
        Points(6,:) = [RVE_Length_1/2 - a, RVE_Length_2/2];
        Points(4,:) = [RVE_Length_1/2, RVE_Length_2/2 + sqrt(3)/2 * a];
        Points(8,:) = [RVE_Length_1/2, RVE_Length_2/2 - sqrt(3)/2 * a];
        
        Points(3,:) = [RVE_Length_1/2 + a/2, RVE_Length_2/2 + sqrt(3)/2 * a];
        Points(5,:) = [RVE_Length_1/2 - a/2, RVE_Length_2/2 + sqrt(3)/2 * a];
        Points(7,:) = [RVE_Length_1/2 - a/2, RVE_Length_2/2 - sqrt(3)/2 * a];
        Points(9,:) = [RVE_Length_1/2 + a/2, RVE_Length_2/2 - sqrt(3)/2 * a];
        
        Points(14,:) = [RVE_Length_1/2 - a/2, 0];
        Points(26,:) = [RVE_Length_1/2, 0];
        Points(13,:) = [RVE_Length_1/2 + a/2, 0];
        
        Points(19,:) = [RVE_Length_1/2 - a/2, RVE_Length_2];
        Points(31,:) = [RVE_Length_1/2, RVE_Length_2];
        Points(20,:) = [RVE_Length_1/2 + a/2, RVE_Length_2];
        
    otherwise
        
        ErrCode = -1;
        fprintf (1, '\nОшибка функции Construct_Geometry: недопустимое значение параметра Soric_Model !\n');
        return;
end

fprintf (1, 'OK!\n');
